Index: riece/Makefile
===================================================================
RCS file: /home/ncvs/ports/irc/riece/Makefile,v
retrieving revision 1.17
diff -d -u -I\$FreeBSD:.*\$ -I\$NetBSD:.*\$ -I\$OpenBSD:.*\$ -I\$DragonFly:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.17 Makefile
--- riece/Makefile	4 Feb 2004 04:36:02 -0000	1.17
+++ riece/Makefile	29 Oct 2004 16:36:08 -0000
@@ -1,70 +1,27 @@
-# New ports collection makefile for:	liece (for emacs21)
-# Date Created:		9 Mar 2001
-# Whom:			Yoichi NAKAYAMA <yoichi@eken.phys.nagoya-u.ac.jp>
+# New ports collection makefile for:	riece
+# Date created: 	30 May 2004
+# Whom:			KIMURA Yasuhiro <yasu@utahime.org>
 #
 # $FreeBSD: ports/irc/riece/Makefile,v 1.17 2004/02/04 04:36:02 marcus Exp $
-#
 
-PORTNAME=	liece
-PORTVERSION=	1.4.10
-PORTREVISION=	1
+PORTNAME=	riece
+PORTVERSION=	1.0.4
 CATEGORIES=	irc elisp
-MASTER_SITES=	http://www.unixuser.org/~ueno/liece/dist/
+MASTER_SITES=	http://wiliki.designflaw.org/riece/
 PKGNAMESUFFIX=	-${EMACS_PORT_NAME}
 
-MAINTAINER=	yoichi@FreeBSD.org
-COMMENT=	Yet another IRC client which runs under Emacsen
-
-BUILD_DEPENDS+=	${LOCALBASE}/${EMACS_VERSION_SITE_LISPDIR}/apel/install.el:${PORTSDIR}/editors/apel${DEPPORT_SUFFIX}
-RUN_DEPENDS+=	${LOCALBASE}/${EMACS_VERSION_SITE_LISPDIR}/apel/install.el:${PORTSDIR}/editors/apel${DEPPORT_SUFFIX} \
-		ldcc:${PORTSDIR}/irc/liece-dcc
-
-HAS_CONFIGURE=	yes
-USE_GETTEXT=	yes
-USE_GMAKE=	yes
+MAINTAINER=	yasu@utahime.org
+COMMENT=	IRC client for Emacs
 
 EMACS_PORT_NAME?=	emacs21
-
-DIRSECTION?=		"The Emacs editor and associated tools"
-INFOENTRY?=		"* Liece: (liece).		IRC client on Emacsen."
-
-.if ${EMACS_PORT_NAME} == "emacs21"
-DEPPORT_SUFFIX=		
-.else
-DEPPORT_SUFFIX=	-${EMACS_PORT_NAME}
-.endif
-
+GNU_CONFIGURE=	yes
 CONFIGURE_ARGS=	--with-emacs=${EMACS_CMD} \
-		--with-lispdir=${PREFIX}/${EMACS_VERSION_SITE_LISPDIR} \
-		--datadir=${PREFIX}/share
-MAKE_ARGS+=	LISPDIR=${PREFIX}/${EMACS_VERSION_SITE_LISPDIR}
-LIECE_ETCDIR=	share/${PORTNAME}
-
-BUILD_WRKSRC=	${WRKSRC}/lisp
-INSTALL_WRKSRC=	${BUILD_WRKSRC}
-PLIST_SUB=	LIECE_LISPDIR=${EMACS_VERSION_SITE_LISPDIR}/${PORTNAME} \
-		LIECE_ETCDIR=${LIECE_ETCDIR} \
-		DIRSECTION=${DIRSECTION} INFOENTRY=${INFOENTRY}
+		--with-lispdir=${PREFIX}/${EMACS_VERSION_SITE_LISPDIR}
+USE_GMAKE=	yes
 
-DOCS=		AUTHORS lisp/ChangeLog
+INFO=	riece-ja
 
-post-build:
-	(cd ${WRKSRC}/etc/po ; msgfmt -o liece.mo ja.po)
 post-install:
-	(cd ${WRKSRC}/etc ; ${SETENV} ${MAKE_ENV} ${GMAKE} ${MAKE_FLAGS} ${MAKEFILE} ${MAKE_ARGS} install)
-	${INSTALL_DATA} ${WRKSRC}/etc/gnu-emacs-user-config ${PREFIX}/${LIECE_ETCDIR}
-	${MKDIR} ${PREFIX}/${LIECE_ETCDIR}/icons
-	${INSTALL_DATA} ${WRKSRC}/etc/icons/*.xpm ${PREFIX}/${LIECE_ETCDIR}/icons
-	${LN} -sf ja ${PREFIX}/${LIECE_ETCDIR}/locale/ja_JP.EUC
-	${LN} -sf ja ${PREFIX}/${LIECE_ETCDIR}/locale/ja_JP.eucJP
-.if !defined(NOPORTDOCS)
-	${MKDIR} ${PREFIX}/${LIECE_ETCDIR}/doc
-.for f in ${DOCS}
-	${INSTALL_DATA} ${WRKSRC}/${f} ${PREFIX}/${LIECE_ETCDIR}/doc/
-.endfor
-	${INSTALL_DATA} ${WRKSRC}/doc/liece.info ${PREFIX}/info/
-	install-info --section=${DIRSECTION} --entry=${INFOENTRY} \
-		${PREFIX}/info/liece.info ${PREFIX}/info/dir
-.endif
+	@${CAT} ${PKGMESSAGE}
 
 .include <bsd.port.mk>
Index: riece/distinfo
===================================================================
RCS file: /home/ncvs/ports/irc/riece/distinfo,v
retrieving revision 1.7
diff -d -u -I\$FreeBSD:.*\$ -I\$NetBSD:.*\$ -I\$OpenBSD:.*\$ -I\$DragonFly:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.7 distinfo
--- riece/distinfo	31 Mar 2004 03:08:32 -0000	1.7
+++ riece/distinfo	29 Oct 2004 16:29:15 -0000
@@ -1,2 +1,2 @@
-MD5 (liece-1.4.10.tar.gz) = 33e7b46f17010cf43146467abc669dc2
-SIZE (liece-1.4.10.tar.gz) = 217046
+MD5 (riece-1.0.4.tar.gz) = a26706e89784b9d32897ed9a4e475d71
+SIZE (riece-1.0.4.tar.gz) = 294170
Index: riece/pkg-descr
===================================================================
RCS file: /home/ncvs/ports/irc/riece/pkg-descr,v
retrieving revision 1.1
diff -d -u -I\$FreeBSD:.*\$ -I\$NetBSD:.*\$ -I\$OpenBSD:.*\$ -I\$DragonFly:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.1 pkg-descr
--- riece/pkg-descr	10 Apr 2001 09:19:55 -0000	1.1
+++ riece/pkg-descr	29 Oct 2004 16:26:46 -0000
@@ -1,7 +1,13 @@
-Liece is an IRC client which runs under Emacsen.
-
-Put the expression below into your ~/.emacs.
+Riece is an IRC client for Emacs. It provides the following features:
 
-(autoload 'liece "liece" nil t)
+- Several IRC servers may be used at the same time.
+- Essential features can be built upon the extension framework (called
+  "add-on") capable of dependency tracking.
+- Installation is easy.  Riece doesn't depend on other packages.
+- Setup is easy.  Automatically save/restore the configuration.
+- Riece uses separate windows to display users, channels, and
+  dialogues.  The user can select the window layout.
+- Step-by-step instructions (currently written in Japanese) are included.
+- Mostly compliant with RFC 2812.
 
-WWW: http://www.unixuser.org/~ueno/liece/index.html.en
+WWW: http://www.nongnu.org/riece/
Index: riece/pkg-plist
===================================================================
RCS file: /home/ncvs/ports/irc/riece/pkg-plist,v
retrieving revision 1.8
diff -d -u -I\$FreeBSD:.*\$ -I\$NetBSD:.*\$ -I\$OpenBSD:.*\$ -I\$DragonFly:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.8 pkg-plist
--- riece/pkg-plist	5 Oct 2002 20:24:14 -0000	1.8
+++ riece/pkg-plist	29 Oct 2004 16:32:53 -0000
@@ -1,114 +1,110 @@
-%%LIECE_ETCDIR%%/icons/back.xpm
-%%LIECE_ETCDIR%%/icons/ball.blank.xpm
-%%LIECE_ETCDIR%%/icons/ball.gray.xpm
-%%LIECE_ETCDIR%%/icons/ball.red.xpm
-%%LIECE_ETCDIR%%/icons/balloon.xpm
-%%LIECE_ETCDIR%%/icons/crypt.xpm
-%%LIECE_ETCDIR%%/icons/encrypt.xpm
-%%LIECE_ETCDIR%%/icons/forward.xpm
-%%LIECE_ETCDIR%%/icons/home.xpm
-%%LIECE_ETCDIR%%/icons/icons.xpm
-%%LIECE_ETCDIR%%/icons/key.xpm
-%%LIECE_ETCDIR%%/icons/liece-pointer.xpm
-%%LIECE_ETCDIR%%/icons/location.xpm
-%%LIECE_ETCDIR%%/icons/naruto.blank.xpm
-%%LIECE_ETCDIR%%/icons/naruto.gray.xpm
-%%LIECE_ETCDIR%%/icons/naruto.red.xpm
-%%LIECE_ETCDIR%%/icons/pindown.xpm
-%%LIECE_ETCDIR%%/icons/print.xpm
-%%LIECE_ETCDIR%%/icons/reload.xpm
-%%LIECE_ETCDIR%%/icons/search.xpm
-%%LIECE_ETCDIR%%/icons/stop.xpm
-%%LIECE_ETCDIR%%/locale/ja/LC_MESSAGES/liece.mo
-%%LIECE_ETCDIR%%/locale/ja_JP.EUC
-%%LIECE_ETCDIR%%/locale/ja_JP.eucJP
-%%LIECE_ETCDIR%%/styles/bottom
-%%LIECE_ETCDIR%%/styles/middle
-%%LIECE_ETCDIR%%/styles/top
-%%LIECE_ETCDIR%%/gnu-emacs-user-config
-%%PORTDOCS%%@unexec install-info --delete --section="%%DIRSECTION%%" --entry="%%INFOENTRY%%" %D/info/liece.info %D/info/dir
-%%PORTDOCS%%info/liece.info
-%%PORTDOCS%%@exec install-info --section="%%DIRSECTION%%" --entry="%%INFOENTRY%%" %D/info/liece.info %D/info/dir
-%%PORTDOCS%%%%LIECE_ETCDIR%%/doc/AUTHORS
-%%PORTDOCS%%%%LIECE_ETCDIR%%/doc/ChangeLog
-%%PORTDOCS%%@dirrm %%LIECE_ETCDIR%%/doc
-@dirrm %%LIECE_ETCDIR%%/icons
-@dirrm %%LIECE_ETCDIR%%/locale/ja/LC_MESSAGES
-@dirrm %%LIECE_ETCDIR%%/locale/ja
-@dirrm %%LIECE_ETCDIR%%/locale
-@dirrm %%LIECE_ETCDIR%%/styles
-@dirrm %%LIECE_ETCDIR%%
-%%LIECE_LISPDIR%%/bitmap-stipple.el
-%%LIECE_LISPDIR%%/bitmap-stipple.elc
-%%LIECE_LISPDIR%%/gettext.el
-%%LIECE_LISPDIR%%/gettext.elc
-%%LIECE_LISPDIR%%/liece-000.el
-%%LIECE_LISPDIR%%/liece-000.elc
-%%LIECE_LISPDIR%%/liece-200.el
-%%LIECE_LISPDIR%%/liece-200.elc
-%%LIECE_LISPDIR%%/liece-300.el
-%%LIECE_LISPDIR%%/liece-300.elc
-%%LIECE_LISPDIR%%/liece-400.el
-%%LIECE_LISPDIR%%/liece-400.elc
-%%LIECE_LISPDIR%%/liece-500.el
-%%LIECE_LISPDIR%%/liece-500.elc
-%%LIECE_LISPDIR%%/liece-channel.el
-%%LIECE_LISPDIR%%/liece-channel.elc
-%%LIECE_LISPDIR%%/liece-clfns.el
-%%LIECE_LISPDIR%%/liece-clfns.elc
-%%LIECE_LISPDIR%%/liece-coding.el
-%%LIECE_LISPDIR%%/liece-coding.elc
-%%LIECE_LISPDIR%%/liece-commands.el
-%%LIECE_LISPDIR%%/liece-commands.elc
-%%LIECE_LISPDIR%%/liece-compat.el
-%%LIECE_LISPDIR%%/liece-compat.elc
-%%LIECE_LISPDIR%%/liece-ctcp.el
-%%LIECE_LISPDIR%%/liece-ctcp.elc
-%%LIECE_LISPDIR%%/liece-dcc.el
-%%LIECE_LISPDIR%%/liece-dcc.elc
-%%LIECE_LISPDIR%%/liece-filter.el
-%%LIECE_LISPDIR%%/liece-filter.elc
-%%LIECE_LISPDIR%%/liece-globals.el
-%%LIECE_LISPDIR%%/liece-globals.elc
-%%LIECE_LISPDIR%%/liece-handle.el
-%%LIECE_LISPDIR%%/liece-handle.elc
-%%LIECE_LISPDIR%%/liece-handler.el
-%%LIECE_LISPDIR%%/liece-handler.elc
-%%LIECE_LISPDIR%%/liece-hilit.el
-%%LIECE_LISPDIR%%/liece-hilit.elc
-%%LIECE_LISPDIR%%/liece-inlines.el
-%%LIECE_LISPDIR%%/liece-inlines.elc
-%%LIECE_LISPDIR%%/liece-intl.el
-%%LIECE_LISPDIR%%/liece-intl.elc
-%%LIECE_LISPDIR%%/liece-mail.el
-%%LIECE_LISPDIR%%/liece-mail.elc
-%%LIECE_LISPDIR%%/liece-menu.el
-%%LIECE_LISPDIR%%/liece-menu.elc
-%%LIECE_LISPDIR%%/liece-message.el
-%%LIECE_LISPDIR%%/liece-message.elc
-%%LIECE_LISPDIR%%/liece-minibuf.el
-%%LIECE_LISPDIR%%/liece-minibuf.elc
-%%LIECE_LISPDIR%%/liece-misc.el
-%%LIECE_LISPDIR%%/liece-misc.elc
-%%LIECE_LISPDIR%%/liece-nick.el
-%%LIECE_LISPDIR%%/liece-nick.elc
-%%LIECE_LISPDIR%%/liece-q-el.el
-%%LIECE_LISPDIR%%/liece-q-el.elc
-%%LIECE_LISPDIR%%/liece-setup.el
-%%LIECE_LISPDIR%%/liece-tcp.el
-%%LIECE_LISPDIR%%/liece-tcp.elc
-%%LIECE_LISPDIR%%/liece-url.el
-%%LIECE_LISPDIR%%/liece-url.elc
-%%LIECE_LISPDIR%%/liece-vars.el
-%%LIECE_LISPDIR%%/liece-vars.elc
-%%LIECE_LISPDIR%%/liece-version.el
-%%LIECE_LISPDIR%%/liece-version.elc
-%%LIECE_LISPDIR%%/liece-window.el
-%%LIECE_LISPDIR%%/liece-window.elc
-%%LIECE_LISPDIR%%/liece-x-face.el
-%%LIECE_LISPDIR%%/liece-x-face.elc
-%%LIECE_LISPDIR%%/liece-emacs.el
-%%LIECE_LISPDIR%%/liece-emacs.elc
-%%LIECE_LISPDIR%%/liece.el
-%%LIECE_LISPDIR%%/liece.elc
-@dirrm %%LIECE_LISPDIR%%
+@comment $FreeBSD$
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-000.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-000.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-200.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-200.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-300.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-300.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-400.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-400.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-500.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-500.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-addon.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-addon.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-alias.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-alias.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-async.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-async.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-biff.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-biff.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-button.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-button.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-channel.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-channel.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-coding.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-coding.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-commands.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-commands.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-compat.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-compat.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-complete.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-complete.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-ctcp.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-ctcp.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-ctlseq.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-ctlseq.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-display.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-display.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-doctor.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-doctor.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-emacs.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-emacs.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-filter.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-filter.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-foolproof.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-foolproof.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-globals.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-globals.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-guess.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-guess.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-handle.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-handle.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-hangman.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-hangman.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-highlight.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-highlight.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-history.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-history.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-icon.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-icon.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-identity.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-identity.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-ignore.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-ignore.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-irc.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-irc.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-kakasi.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-kakasi.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-keyword.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-keyword.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-layout.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-layout.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-log.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-log.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-lsdb.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-lsdb.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-menu.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-menu.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-message.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-message.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-mini.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-mini.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-misc.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-misc.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-mode.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-mode.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-naming.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-naming.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-options.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-options.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-rdcc.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-rdcc.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-server.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-server.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-signal.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-signal.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-skk-kakutei.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-skk-kakutei.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-unread.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-unread.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-url.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-url.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-user.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-user.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-version.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-version.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-xface.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece-xface.elc
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece.el
+%%EMACS_VERSION_SITE_LISPDIR%%/riece/riece.elc
+@dirrm %%EMACS_VERSION_SITE_LISPDIR%%/riece
Index: riece-emacs20/Makefile
===================================================================
RCS file: /home/ncvs/ports/irc/riece-emacs20/Makefile,v
retrieving revision 1.6
diff -d -u -I\$FreeBSD:.*\$ -I\$NetBSD:.*\$ -I\$OpenBSD:.*\$ -I\$DragonFly:.*\$ -I\$Id:.*\$ -I\$hrs:.*\$ -r1.6 Makefile
--- riece-emacs20/Makefile	12 Feb 2002 09:26:57 -0000	1.6
+++ riece-emacs20/Makefile	29 Oct 2004 16:39:33 -0000
@@ -1,12 +1,10 @@
-# New ports collection makefile for:	liece (for emacs20)
-# Date Created:		9 Mar 2001
-# Whom:			Yoichi NAKAYAMA <yoichi@eken.phys.nagoya-u.ac.jp>
+# New ports collection makefile for:	riece-emacs20
+# Date created: 	30 May 2004
+# Whom:			KIMURA Yasuhiro <yasu@utahime.org>
 #
 # $FreeBSD: ports/irc/riece-emacs20/Makefile,v 1.6 2002/02/12 09:26:57 yoichi Exp $
-#
-
 
-MASTERDIR=	${.CURDIR}/../liece
+MASTERDIR=	${.CURDIR}/../riece
 
 EMACS_PORT_NAME=	emacs20
 