Index: Makefile.inc1
===================================================================
--- Makefile.inc1	(revision 259128)
+++ Makefile.inc1	(working copy)
@@ -234,7 +234,7 @@
 		SSP_CFLAGS= \
 		-DWITHOUT_HTML -DWITHOUT_INFO -DNO_LINT -DWITHOUT_MAN \
 		-DNO_PIC -DWITHOUT_PROFILE -DNO_SHARED \
-		-DNO_CPU_CFLAGS -DNO_WARNS -DNO_CTF
+		-DNO_CPU_CFLAGS -DNO_WARNS -DNO_CTF -DEARLY_BUILD
 
 # build-tools stage
 TMAKE=		MAKEOBJDIRPREFIX=${OBJTREE} \
@@ -243,7 +243,7 @@
 		DESTDIR= \
 		SSP_CFLAGS= \
 		BOOTSTRAPPING=${OSRELDATE} -DNO_LINT -DNO_CPU_CFLAGS \
-		-DNO_WARNS -DNO_CTF
+		-DNO_WARNS -DNO_CTF -DEARLY_BUILD
 
 # cross-tools stage
 XMAKE=		TOOLS_PREFIX=${WORLDTMP} ${BMAKE} \
@@ -469,7 +469,7 @@
 .for _dir in lib/ncurses/ncurses lib/ncurses/ncursesw lib/libmagic
 	cd ${.CURDIR}/${_dir}; \
 	    MAKEOBJDIRPREFIX=${OBJTREE}/lib32 ${MAKE} SSP_CFLAGS= DESTDIR= \
-	    DIRPRFX=${_dir}/ build-tools
+	    DIRPRFX=${_dir}/ -DNO_CTF -DEARLY_BUILD build-tools
 .endfor
 	cd ${.CURDIR}; \
 	    ${LIB32WMAKE} -f Makefile.inc1 libraries
@@ -779,7 +779,8 @@
 	cd ${KRNLOBJDIR}/${_kernel}; \
 	    PATH=${BPATH}:${PATH} \
 	    MAKESRCPATH=${KERNSRCDIR}/dev/aic7xxx/aicasm \
-	    ${MAKE} SSP_CFLAGS= -DNO_CPU_CFLAGS -DNO_CTF \
+	    MAKEINCPATH=${WORLDTMP}/usr/include \
+	    ${MAKE} SSP_CFLAGS= -DNO_CPU_CFLAGS -DNO_CTF -DEARLY_BUILD WARNS=0 \
 	    -f ${KERNSRCDIR}/dev/aic7xxx/aicasm/Makefile
 # XXX - Gratuitously builds aicasm in the ``makeoptions NO_MODULES'' case.
 .if !defined(MODULES_WITH_WORLD) && !defined(NO_MODULES) && exists(${KERNSRCDIR}/modules)
@@ -787,7 +788,9 @@
 	cd ${KERNSRCDIR}/modules/aic7xxx/aicasm; \
 	    PATH=${BPATH}:${PATH} \
 	    MAKEOBJDIRPREFIX=${KRNLOBJDIR}/${_kernel}/modules \
-	    ${MAKE} SSP_CFLAGS= -DNO_CPU_CFLAGS -DNO_CTF ${target}
+	    MAKEINCPATH=${WORLDTMP}/usr/include \
+	    ${MAKE} SSP_CFLAGS= -DNO_CPU_CFLAGS -DNO_CTF -DEARLY_BUILD WARNS=0 \
+	    ${target}
 .endfor
 .endif
 .if !defined(NO_KERNELDEPEND)
@@ -982,8 +985,10 @@
     ${_gperf} \
     ${_groff} \
     ${_ar} \
-    ${_yacc} \
-    ${_lex} \
+    lib/liby \
+    usr.bin/yacc \
+    usr.bin/lex \
+    gnu/usr.bin/patch \
     usr.bin/lorder \
     usr.bin/makewhatis \
     ${_mklocale} \
@@ -1084,7 +1089,7 @@
 		cd ${.CURDIR}/${_tool}; \
 		${MAKE} DIRPRFX=${_tool}/ obj; \
 		${MAKE} DIRPRFX=${_tool}/ depend; \
-		${MAKE} DIRPRFX=${_tool}/ all; \
+		${MAKE} DIRPRFX=${_tool}/ COPTS=-O0 all; \
 		${MAKE} DIRPRFX=${_tool}/ DESTDIR=${MAKEOBJDIRPREFIX} install
 .endfor
 
Index: release/Makefile
===================================================================
--- release/Makefile	(revision 259128)
+++ release/Makefile	(working copy)
@@ -556,7 +556,7 @@
 	echo "fi"				>> ${_MK}
 	echo "if [ ! -f /tmp/.world_done ]; then" >> ${_MK}
 	echo "	cd /usr/src"			>> ${_MK}
-	echo "	${CROSSMAKE} ${WORLD_FLAGS} -DNO_CLEAN buildworld && \\" >> ${_MK}
+	echo "	${CROSSMAKE} ${WORLD_FLAGS:N-j*} -DNO_CLEAN buildworld && \\" >> ${_MK}
 	echo "	touch /tmp/.world_done || exit 1" >> ${_MK}
 	echo "fi"				>> ${_MK}
 	echo "if [ ! -f /tmp/.skip_ports_index ]; then" >> ${_MK}
Index: contrib/gcc/toplev.h
===================================================================
--- contrib/gcc/toplev.h	(revision 259128)
+++ contrib/gcc/toplev.h	(working copy)
@@ -158,6 +158,7 @@
 extern int floor_log2                  (unsigned HOST_WIDE_INT);
 
 /* Inline versions of the above for speed.  */
+#ifndef __llvm__
 #if GCC_VERSION >= 3004
 # if HOST_BITS_PER_WIDE_INT == HOST_BITS_PER_LONG
 #  define CLZ_HWI __builtin_clzl
@@ -182,6 +183,7 @@
   return x == (x & -x) && x ? (int) CTZ_HWI (x) : -1;
 }
 #endif /* GCC_VERSION >= 3004 */
+#endif /* !__llvm__ */
 
 /* Functions used to get and set GCC's notion of in what directory
    compilation was started.  */
Index: share/mk/bsd.prog.mk
===================================================================
--- share/mk/bsd.prog.mk	(revision 259128)
+++ share/mk/bsd.prog.mk	(working copy)
@@ -134,7 +134,7 @@
 .endif
 .else
 	echo ${PROG}: ${LIBC} ${DPADD} >> ${DEPENDFILE}
-.if defined(PROG_CXX)
+.if defined(PROG_CXX) && !defined(EARLY_BUILD)
 	echo ${PROG}: ${LIBSTDCPLUSPLUS} >> ${DEPENDFILE}
 .endif
 .endif
Index: sys/dev/aic7xxx/aicasm/Makefile
===================================================================
--- sys/dev/aic7xxx/aicasm/Makefile	(revision 259128)
+++ sys/dev/aic7xxx/aicasm/Makefile	(working copy)
@@ -30,10 +30,13 @@
 .else
 NOSTDINC=	-nostdinc
 .endif
-CFLAGS+= ${NOSTDINC} -I/usr/include -I.
+CFLAGS+= ${NOSTDINC} -I.
 .ifdef MAKESRCPATH
 CFLAGS+= -I${MAKESRCPATH}
 .endif
+.ifdef MAKEINCPATH
+CFLAGS+= -I${MAKEINCPATH}
+.endif
 NO_MAN=
 YFLAGS= -b ${.TARGET:R} ${.TARGET:M*macro*:S/$(.TARGET)/-p mm/} -d
 LFLAGS+= ${.TARGET:M*macro*:S/$(.TARGET)/-Pmm/}
Index: sys/dev/aic7xxx/aicasm/aicasm.c
===================================================================
--- sys/dev/aic7xxx/aicasm/aicasm.c	(revision 259128)
+++ sys/dev/aic7xxx/aicasm/aicasm.c	(working copy)
@@ -530,7 +530,7 @@
 	int instrptr;
 	unsigned int line;
 	int func_count;
-	int skip_addr;
+	unsigned int skip_addr;
 
 	instrcount = 0;
 	instrptr = 0;
Index: sys/dev/aic7xxx/aicasm/aicasm_macro_scan.l
===================================================================
--- sys/dev/aic7xxx/aicasm/aicasm_macro_scan.l	(revision 259128)
+++ sys/dev/aic7xxx/aicasm/aicasm_macro_scan.l	(working copy)
@@ -70,6 +70,8 @@
 extern int mmlex(void);
 %}
 
+%option noinput
+
 WORD		[A-Za-z_][-A-Za-z_0-9]*
 SPACE		[ \t]+
 MCARG		[^(), \t]+
Index: sys/dev/aic7xxx/aicasm/aicasm_scan.l
===================================================================
--- sys/dev/aic7xxx/aicasm/aicasm_scan.l	(revision 259128)
+++ sys/dev/aic7xxx/aicasm/aicasm_scan.l	(working copy)
@@ -76,6 +76,8 @@
 extern void mm_delete_buffer(YY_BUFFER_STATE);
 %}
 
+%option noinput
+
 PATH		([/]*[-A-Za-z0-9_.])+
 WORD		[A-Za-z_][-A-Za-z_0-9]*
 SPACE		[ \t]+